/* LLgen generated code from source program.g */
/* $Header: /home/curly/levi/xemp/parse/RCS/program.c,v 1.1 1993/02/27 19:01:39 levi Exp $ */
#ifdef LL_DEBUG
#define LL_assert(x) if(!(x)) LL_badassertion("x",__FILE__,__LINE__)
#else
#define LL_assert(x)	/* nothing */
#endif

extern int LLsymb;

#define LL_SAFE(x)	/* Nothing */
#define LL_SSCANDONE(x)	if (LLsymb != x) LLerror(x); else
#define LL_SCANDONE(x)	if (LLsymb != x) LLerror(x); else
#define LL_NOSCANDONE(x) LLscan(x)
#ifdef LL_FASTER
#define LLscan(x)	if ((LLsymb = LL_LEXI()) != x) LLerror(x); else
#endif

# include "Lpars.h"

extern unsigned int LLscnt[];
extern unsigned int LLtcnt[];
extern int LLcsymb;

#define LLsdecr(d)	{LL_assert(LLscnt[d] > 0); LLscnt[d]--;}
#define LLtdecr(d)	{LL_assert(LLtcnt[d] > 0); LLtcnt[d]--;}
#define LLsincr(d)	LLscnt[d]++
#define LLtincr(d)	LLtcnt[d]++
#define LL_LEXI NextToken
# line 4 "program.g"

#include "parser.h"
#include "symtab.h"
#include "token.h"
#include "stack.h"
#include "Lpars.h"

#include "parser.h"
#include "prog_defs.h"

static void DestroyAction();

#include "program.inc"

static void SetCommodityType(token, commodity)
int token, *commodity;
{
	switch (token) {
		case FOOD:	*commodity = 'f'; break;
		case DUST:	*commodity = 'd'; break;
		case OIL:	*commodity = 'o'; break;
		case IRON:	*commodity = 'i'; break;
		case UW:	*commodity = 'u'; break;
		case GUNS:	*commodity = 'g'; break;
		case BARS:	*commodity = 'b'; break;
		case PETROL:	*commodity = 'p'; break;
		case LCMS:	*commodity = 'l'; break;
		case HCMS:	*commodity = 'h'; break;
		case SHELLS:	*commodity = 's'; break;
		case RADS:	*commodity = 'r'; break;
	}
}

static void LinkExprList(list, expr)
ExprList *list;
Stack expr;
{
	ExprList new = (ExprList) doalloc(sizeof(struct _ExprList));

	if (*list == NULL) {
		*list = (ExprList) doalloc(sizeof(struct _ExprList));
		(*list)->e_tail = *list;
	}

	new->e_expr = expr;
	new->next   = NULL;

	(*list)->e_tail->next = new;
	(*list)->e_tail = new;
}

static void LinkOutputList(list, expr)
Output *list;
Stack expr;
{
	Output new = (Output) doalloc(sizeof(struct _Outp));

	if (*list == NULL) {
		*list = (Output) doalloc(sizeof(struct _Outp));
		(*list)->o_tail = *list;
	}

	new->next   = NULL;
	new->format = 0;
	new->o_expr = expr;

	(*list)->o_tail->next = new;
	(*list)->o_tail = new;
}

static void SetActionStruct(action, type)
Action action;
int type;
{
	action->type = type;

	switch (type) {
	case MOVE:
		action->u_move = (Move) doalloc(sizeof(struct _Move));
		memset(action->u_move, '\0', sizeof(struct _Move));
		break;
	case SET_DISTRIBUTE:
		action->u_distribute = (Distribute)
					doalloc(sizeof(struct _Distribute));
		memset(action->u_distribute, '\0', sizeof(struct _Distribute));
		break;
	case SET_DELIVER:
		action->u_deliver = (Deliver)
					doalloc(sizeof(struct _Deliver));
		memset(action->u_deliver, '\0', sizeof(struct _Deliver));
		break;
	case PRINT:
	case SEND:
		break;
	default:
		action->u_simple = (Simple) doalloc(sizeof(struct _Simple));
		memset(action->u_simple, '\0', sizeof(struct _Simple));
	}
}

static void DestroyExprList(expr_list)
ExprList *expr_list;
{
	ExprList ptr, next;

	if ((ptr = *expr_list) == NULL)
		return;

	ptr = ptr->next;
	while (ptr != NULL) {
		DestroyExpression(&ptr->e_expr);

		next = ptr->next;
		dofree((char *) ptr);
		ptr = next;
	}

	dofree((char *) *expr_list);
}

static void DestroyOutputList(output_list)
Output *output_list;
{
	Output ptr, next;

	if ((ptr = *output_list) == NULL)
		return;

	ptr = ptr->next;
	while (ptr != NULL) {
		DestroyExpression(&ptr->o_expr);

		next = ptr->next;
		dofree((char *) ptr);
		ptr = next;
	}
}

static void DestroyLocation(loc)
Location loc;
{
	switch (loc->type) {
	case LOC_SECTOR:
		DestroyExpression(&loc->l_sector_expr);
		break;
	case LOC_WHERE:
		DestroyExprList(&loc->l_where_list);
		break;
	}
}

static void DestroyAction(action_ptr)
Action *action_ptr;
{
	Action action = *action_ptr;

	switch (action->type) {
	case MOVE:
		DestroyExpression(&action->u_move->quantity);
		DestroyLocation(&action->u_move->from_loc);
		DestroyExprList(&action->u_move->via_list);
		DestroyLocation(&action->u_move->to_loc);
		break;
	case SET_DISTRIBUTE:
		DestroyExpression(&action->u_distribute->sector_expr);
		DestroyLocation(&action->u_distribute->to_loc);
		break;
	case SET_DELIVER:
		DestroyExpression(&action->u_deliver->sector_expr);
		DestroyExpression(&action->u_deliver->dest_sector);
		break;
	case PRINT:
	case SEND:
		DestroyOutputList(&action->u_output);
		break;
	default:
		DestroyExpression(&action->u_simple->sector_expr);
		DestroyExpression(&action->u_simple->quantity);
	}

	if (action->u_simple != NULL)
		dofree((char *) action->u_simple);	
	dofree((char *) action);
}

L1_parse_program (
) {
LLsincr(12);
L20_statement(
# line 195 "program.g"
-1, -1);
}
L21_block_statement (
# line 198 "program.g"
 label_cont,label_break) int label_cont; int label_break; {
LLsincr(12);
LLtincr(56);
LL_SAFE(BEGIN);
LLread();
for (;;) {
L_1 : {switch(LLcsymb) {
case /*  END  */ 56 : ;
break;
default:{int LL_8=LLnext(-252);
;if (!LL_8) {
break;
}
else if (LL_8 & 1) goto L_1;}
case /*  BEGIN  */ 55 : ;
case /*  REPEAT  */ 57 : ;
case /*  WHILE  */ 59 : ;
case /*  IF  */ 61 : ;
case /*  LOOP  */ 64 : ;
case /*  MOVE  */ 65 : ;
case /*  SET_DESIGNATION  */ 70 : ;
case /*  DEMOBILIZE  */ 71 : ;
case /*  ENLIST  */ 73 : ;
case /*  CONVERT  */ 74 : ;
case /*  SHOOT  */ 75 : ;
case /*  TERRITORY  */ 76 : ;
case /*  SET_DISTRIBUTE  */ 77 : ;
case /*  SET_THRESHOLD  */ 78 : ;
case /*  SET_CUTOFF  */ 79 : ;
case /*  SET_DELIVER  */ 80 : ;
case /*  BREAK  */ 82 : ;
case /*  CONTINUE  */ 83 : ;
case /*  ABORT  */ 84 : ;
case /*  STOP  */ 85 : ;
case /*  PRINT  */ 86 : ;
case /*  SEND  */ 87 : ;
case /*  TOKEN_STATEMENT  */ 157 : ;
LLsincr(12);
L20_statement(
# line 199 "program.g"
label_cont, label_break);
continue;
}
}
LLsdecr(12);
break;
}
LLtdecr(56);
LL_SSCANDONE(END);
}
L20_statement (
# line 202 "program.g"
 label_cont,label_break) int label_cont; int label_break; {
L_2: ;
switch(LLcsymb) {
case /*  BEGIN  */ 55 : ;
LLsdecr(12);
L21_block_statement(
# line 203 "program.g"
label_cont, label_break);
LLread();
break;
case /*  LOOP  */ 64 : ;
LLsdecr(12);
L22_loop_statement(
);
break;
case /*  REPEAT  */ 57 : ;
LLsdecr(12);
L23_repeat_statement(
);
LLread();
break;
case /*  WHILE  */ 59 : ;
LLsdecr(12);
L24_while_statement(
);
break;
case /*  IF  */ 61 : ;
LLsdecr(12);
L25_if_statement(
# line 207 "program.g"
label_cont, label_break);
break;
case /*  MOVE  */ 65 : ;
case /*  SET_DESIGNATION  */ 70 : ;
case /*  DEMOBILIZE  */ 71 : ;
case /*  ENLIST  */ 73 : ;
case /*  CONVERT  */ 74 : ;
case /*  SHOOT  */ 75 : ;
case /*  TERRITORY  */ 76 : ;
case /*  SET_DISTRIBUTE  */ 77 : ;
case /*  SET_THRESHOLD  */ 78 : ;
case /*  SET_CUTOFF  */ 79 : ;
case /*  SET_DELIVER  */ 80 : ;
case /*  PRINT  */ 86 : ;
case /*  SEND  */ 87 : ;
LLsdecr(12);
L26_do_statement(
# line 208 "program.g"
label_cont, label_break);
break;
case /*  STOP  */ 85 : ;
LLsdecr(12);
LL_SAFE(STOP);
# line 209 "program.g"
{ AddInstructionGoto(1);		       }
LLread();
break;
case /*  ABORT  */ 84 : ;
LLsdecr(12);
LL_SAFE(ABORT);
# line 210 "program.g"
{ AddInstructionGoto(2);		       }
LLread();
break;
case /*  CONTINUE  */ 83 : ;
LLsdecr(12);
LL_SAFE(CONTINUE);
# line 211 "program.g"
{ if (label_cont < 0) LLmessage(LLsymb);       }
# line 212 "program.g"
{ AddInstructionGoto(label_cont);	       }
LLread();
break;
case /*  BREAK  */ 82 : ;
LLsdecr(12);
LL_SAFE(BREAK);
# line 213 "program.g"
{ if (label_break < 0) LLmessage(LLsymb);      }
# line 214 "program.g"
{ AddInstructionGoto(label_break);	       }
LLread();
break;
case /*  TOKEN_STATEMENT  */ 157 : ;
L_3: ;
LLsdecr(12);
LL_SSCANDONE(TOKEN_STATEMENT);
LLread();
break;
default: if (LLskip()) goto L_2;
goto L_3;
}
}
L22_loop_statement (
) {
# line 218 "program.g"
 int label_start, label_end, loop_count = -1;
				  Instruction instr_set, instr_test;	       
LLtincr(1);
LLsincr(12);
LL_SAFE(LOOP);
# line 220 "program.g"
{ label_start = next_label++;		       }
# line 221 "program.g"
{ label_end   = next_label++;		       }
LLread();
L_1 : {switch(LLcsymb) {
case /*  BEGIN  */ 55 : ;
case /*  REPEAT  */ 57 : ;
case /*  WHILE  */ 59 : ;
case /*  IF  */ 61 : ;
case /*  LOOP  */ 64 : ;
case /*  MOVE  */ 65 : ;
case /*  SET_DESIGNATION  */ 70 : ;
case /*  DEMOBILIZE  */ 71 : ;
case /*  ENLIST  */ 73 : ;
case /*  CONVERT  */ 74 : ;
case /*  SHOOT  */ 75 : ;
case /*  TERRITORY  */ 76 : ;
case /*  SET_DISTRIBUTE  */ 77 : ;
case /*  SET_THRESHOLD  */ 78 : ;
case /*  SET_CUTOFF  */ 79 : ;
case /*  SET_DELIVER  */ 80 : ;
case /*  BREAK  */ 82 : ;
case /*  CONTINUE  */ 83 : ;
case /*  ABORT  */ 84 : ;
case /*  STOP  */ 85 : ;
case /*  PRINT  */ 86 : ;
case /*  SEND  */ 87 : ;
case /*  TOKEN_STATEMENT  */ 157 : ;
LLtdecr(1);
break;
default:{int LL_9=LLnext(257);
;if (!LL_9) {
LLtdecr(1);
break;
}
else if (LL_9 & 1) goto L_1;}
case /*  CONSTANT  */ 1 : ;
LLtdecr(1);
LL_SAFE(CONSTANT);
# line 223 "program.g"
{ loop_count = current_token.t_constant;       }
LLread();
}
}
# line 224 "program.g"
{ AddInstructionSetCount(loop_count);	       }
# line 225 "program.g"
{ instr_set = LastInstruction();	       }
# line 226 "program.g"
{ AddInstructionLabel(label_start);	       }
# line 227 "program.g"
{ AddInstructionTestCount(label_end);	       }
# line 228 "program.g"
{ instr_test = LastInstruction();	       }
L20_statement(
# line 229 "program.g"
label_start, label_end);
# line 230 "program.g"
{ instr_set->loop_count = &instr_test->number; }
# line 231 "program.g"
{ AddInstructionGoto(label_start);	       }
# line 232 "program.g"
{ AddInstructionLabel(label_end);	       }
}
L23_repeat_statement (
) {
# line 235 "program.g"
 int label_start, label_cont, label_break;
				  Stack expr;				       
LLsincr(12);
LLtincr(58);
LLtincr(21);
LLsincr(11);
LLtincr(22);
LL_SAFE(REPEAT);
# line 237 "program.g"
{ label_break = next_label++;		       }
# line 238 "program.g"
{ label_cont  = next_label++;		       }
# line 239 "program.g"
{ label_start = next_label++;		       }
# line 240 "program.g"
{ AddInstructionLabel(label_start);	       }
LLread();
L20_statement(
# line 241 "program.g"
label_cont, label_break);
LLtdecr(58);
LL_SCANDONE(UNTIL);
LLtdecr(21);
LL_NOSCANDONE(BRACKET_OPEN);
LLsdecr(11);
L3_parse_expression(
# line 244 "program.g"
&expr);
# line 245 "program.g"
{ AddInstructionLabel(label_cont);	       }
LLtdecr(22);
LL_SCANDONE(BRACKET_CLOSE);
# line 246 "program.g"
{ AddInstructionEval(expr, label_start, 0);    }
# line 247 "program.g"
{ AddInstructionLabel(label_break);	       }
}
L24_while_statement (
) {
# line 250 "program.g"
 int label_start, label_end;
				  Stack expr;				       
LLsincr(11);
LLtincr(22);
LLsincr(12);
LL_SAFE(WHILE);
# line 252 "program.g"
{ label_start = next_label++;		       }
# line 253 "program.g"
{ label_end   = next_label++;		       }
LL_NOSCANDONE(BRACKET_OPEN);
# line 254 "program.g"
{ AddInstructionLabel(label_start);	       }
LLsdecr(11);
L3_parse_expression(
# line 255 "program.g"
&expr);
LLtdecr(22);
LL_SCANDONE(BRACKET_CLOSE);
# line 256 "program.g"
{ AddInstructionEval(expr, 0, label_end);      }
LLread();
L20_statement(
# line 257 "program.g"
label_start, label_end);
# line 258 "program.g"
{ AddInstructionGoto(label_start);	       }
# line 259 "program.g"
{ AddInstructionLabel(label_end);	       }
}
L25_if_statement (
# line 262 "program.g"
 label_cont,label_break) int label_cont; int label_break; {
# line 262 "program.g"
 int label_else, label_end;
						  Stack expr;		       
LLsincr(11);
LLtincr(22);
LLtincr(62);
LLsincr(12);
LLtincr(63);
LL_SAFE(IF);
# line 264 "program.g"
{ label_else = next_label++;		       }
LL_NOSCANDONE(BRACKET_OPEN);
# line 265 "program.g"
{ label_end  = next_label++;		       }
LLsdecr(11);
L3_parse_expression(
# line 266 "program.g"
&expr);
LLtdecr(22);
LL_SCANDONE(BRACKET_CLOSE);
# line 267 "program.g"
{ AddInstructionEval(expr, 0, label_else);     }
LLtdecr(62);
LL_NOSCANDONE(THEN);
LLread();
L20_statement(
# line 269 "program.g"
label_cont, label_break);
# line 270 "program.g"
{ AddInstructionGoto(label_end);	       }
# line 271 "program.g"
{ AddInstructionLabel(label_else);	       }
L_1 : {switch(LLcsymb) {
case /*  ELSE  */ 63 : ;
# line 272 "program.g"
if ((LLsymb == ELSE)) goto L_2;
case /*  EOFILE  */ 0 : ;
case /*  BEGIN  */ 55 : ;
case /*  END  */ 56 : ;
case /*  REPEAT  */ 57 : ;
case /*  UNTIL  */ 58 : ;
case /*  WHILE  */ 59 : ;
case /*  IF  */ 61 : ;
case /*  LOOP  */ 64 : ;
case /*  MOVE  */ 65 : ;
case /*  SET_DESIGNATION  */ 70 : ;
case /*  DEMOBILIZE  */ 71 : ;
case /*  ENLIST  */ 73 : ;
case /*  CONVERT  */ 74 : ;
case /*  SHOOT  */ 75 : ;
case /*  TERRITORY  */ 76 : ;
case /*  SET_DISTRIBUTE  */ 77 : ;
case /*  SET_THRESHOLD  */ 78 : ;
case /*  SET_CUTOFF  */ 79 : ;
case /*  SET_DELIVER  */ 80 : ;
case /*  BREAK  */ 82 : ;
case /*  CONTINUE  */ 83 : ;
case /*  ABORT  */ 84 : ;
case /*  STOP  */ 85 : ;
case /*  PRINT  */ 86 : ;
case /*  SEND  */ 87 : ;
case /*  TOKEN_STATEMENT  */ 157 : ;
LLtdecr(63);
break;
default:{int LL_10=LLnext(319);
;if (!LL_10) {
LLtdecr(63);
break;
}
else if (LL_10 & 1) goto L_1;}
L_2 : ;
LLtdecr(63);
LLsincr(12);
LL_SAFE(ELSE);
LLread();
L20_statement(
# line 274 "program.g"
label_cont, label_break);
}
}
# line 275 "program.g"
{  AddInstructionLabel(label_end);	       }
}
L26_do_statement (
# line 278 "program.g"
 label_cont,label_break) int label_cont, label_break; {
# line 279 "program.g"
 Action action = (Action)
					  doalloc(sizeof(struct _Action));
				  int label_next = next_label++;
				  Stack expr;
				  Instruction instr;

				  memset(action, '\0', sizeof(struct _Action));
				  AddInstructionAction(action, label_next);
				  instr = LastInstruction();		       
switch(LLcsymb) {
case /*  MOVE  */ 65 : ;
case /*  SET_DESIGNATION  */ 70 : ;
case /*  DEMOBILIZE  */ 71 : ;
case /*  ENLIST  */ 73 : ;
case /*  CONVERT  */ 74 : ;
case /*  SHOOT  */ 75 : ;
case /*  TERRITORY  */ 76 : ;
case /*  SET_DISTRIBUTE  */ 77 : ;
case /*  SET_THRESHOLD  */ 78 : ;
case /*  SET_CUTOFF  */ 79 : ;
case /*  SET_DELIVER  */ 80 : ;
LLtincr(81);
switch(LLcsymb) {
case /*  MOVE  */ 65 : ;
LLsincr(13);
LLtincr(66);
LLtincr(68);
LLtincr(69);
LLsincr(14);
LL_SAFE(MOVE);
# line 289 "program.g"
{ SetActionStruct(action, MOVE);	       }
L3_parse_expression(
# line 290 "program.g"
&expr);
# line 291 "program.g"
{ action->u_move->quantity  = expr;	       }
L_8: ;
switch(LLcsymb) {
case /*  CIVILIANS  */ 100 : ;
L_9: ;
LLsdecr(13);
LL_SSCANDONE(CIVILIANS);
# line 292 "program.g"
{ action->u_move->commodity = 'c';	       }
break;
default: if (LLskip()) goto L_8;
goto L_9;
case /*  MILITARY  */ 101 : ;
LLsdecr(13);
LL_SAFE(MILITARY);
# line 293 "program.g"
{ action->u_move->commodity = 'm';	       }
break;
case /*  FOOD  */ 43 : ;
case /*  DUST  */ 44 : ;
case /*  OIL  */ 45 : ;
case /*  IRON  */ 46 : ;
case /*  UW  */ 47 : ;
case /*  GUNS  */ 48 : ;
case /*  BARS  */ 49 : ;
case /*  PETROL  */ 50 : ;
case /*  LCMS  */ 51 : ;
case /*  HCMS  */ 52 : ;
case /*  SHELLS  */ 53 : ;
case /*  RADS  */ 54 : ;
case /*  TOKEN_COMMODITY  */ 159 : ;
LLsdecr(13);
LLsincr(15);
L27_commodity(
# line 294 "program.g"
&action->u_move->commodity);
break;
}
LLread();
L_10 : {switch(LLcsymb) {
case /*  VIA  */ 68 : ;
case /*  TO  */ 69 : ;
LLtdecr(66);
break;
default:{int LL_11=LLnext(322);
;if (!LL_11) {
LLtdecr(66);
break;
}
else if (LL_11 & 1) goto L_10;}
case /*  FROM  */ 66 : ;
LLtdecr(66);
LLsincr(14);
LL_SAFE(FROM);
L28_location(
# line 296 "program.g"
&action->u_move->from_loc);
}
}
for (;;) {
L_11 : {switch(LLcsymb) {
case /*  TO  */ 69 : ;
break;
default:{int LL_12=LLnext(324);
;if (!LL_12) {
break;
}
else if (LL_12 & 1) goto L_11;}
case /*  VIA  */ 68 : ;
LL_SAFE(VIA);
LLread();
L7_sector_expression(
# line 297 "program.g"
&expr);
# line 298 "program.g"
{ LinkExprList(&action->u_move->via_list,expr);}
LLread();
continue;
}
}
LLtdecr(68);
break;
}
LLtdecr(69);
LL_SSCANDONE(TO);
L28_location(
# line 300 "program.g"
&action->u_move->to_loc);
break;
case /*  SET_DESIGNATION  */ 70 : ;
LLsincr(1);
LLtincr(69);
LLtincr(2);
LL_SAFE(SET_DESIGNATION);
# line 302 "program.g"
{ SetActionStruct(action, SET_DESIGNATION);	       }
LLread();
L_12 : {switch(LLcsymb) {
case /*  TO  */ 69 : ;
LLsdecr(1);
break;
default:{int LL_13=LLnext(-21);
;if (!LL_13) {
LLsdecr(1);
break;
}
else if (LL_13 & 1) goto L_12;}
case /*  SQUARE_BRACKET_OPEN  */ 23 : ;
case /*  CURRENT  */ 88 : ;
case /*  WAREHOUSE  */ 89 : ;
case /*  TOKEN_SECTOR  */ 156 : ;
LLsdecr(1);
L7_sector_expression(
# line 303 "program.g"
&action->u_designate->sector_expr);
LLread();
}
}
LLtdecr(69);
LL_SCANDONE(TO);
LLtdecr(2);
LL_NOSCANDONE(CHARACTER);
# line 305 "program.g"
{ action->u_designate->flag =
						current_token.t_character;     }
LLread();
break;
default:
LLtincr(72);
LL_SAFE(DEMOBILIZE);
# line 309 "program.g"
{ SetActionStruct(action, DEMOBILIZE);		}
# line 310 "program.g"
{ action->u_demobilize->flag = 'y';		}
L29_default_statement(
# line 311 "program.g"
action->u_demobilize, DEMOBILIZE);
L_13 : {switch(LLcsymb) {
case /*  EOFILE  */ 0 : ;
case /*  BEGIN  */ 55 : ;
case /*  END  */ 56 : ;
case /*  REPEAT  */ 57 : ;
case /*  UNTIL  */ 58 : ;
case /*  WHILE  */ 59 : ;
case /*  IF  */ 61 : ;
case /*  ELSE  */ 63 : ;
case /*  LOOP  */ 64 : ;
case /*  MOVE  */ 65 : ;
case /*  SET_DESIGNATION  */ 70 : ;
case /*  DEMOBILIZE  */ 71 : ;
case /*  ENLIST  */ 73 : ;
case /*  CONVERT  */ 74 : ;
case /*  SHOOT  */ 75 : ;
case /*  TERRITORY  */ 76 : ;
case /*  SET_DISTRIBUTE  */ 77 : ;
case /*  SET_THRESHOLD  */ 78 : ;
case /*  SET_CUTOFF  */ 79 : ;
case /*  SET_DELIVER  */ 80 : ;
case /*  ON_FAIL  */ 81 : ;
case /*  BREAK  */ 82 : ;
case /*  CONTINUE  */ 83 : ;
case /*  ABORT  */ 84 : ;
case /*  STOP  */ 85 : ;
case /*  PRINT  */ 86 : ;
case /*  SEND  */ 87 : ;
case /*  TOKEN_STATEMENT  */ 157 : ;
LLtdecr(72);
break;
default:{int LL_14=LLnext(328);
;if (!LL_14) {
LLtdecr(72);
break;
}
else if (LL_14 & 1) goto L_13;}
case /*  NO_RESERVE  */ 72 : ;
LLtdecr(72);
LL_SAFE(NO_RESERVE);
# line 312 "program.g"
{ action->u_demobilize->flag = 'n';		}
LLread();
}
}
break;
case /*  ENLIST  */ 73 : ;
LL_SAFE(ENLIST);
# line 315 "program.g"
{ SetActionStruct(action, ENLIST);		}
L29_default_statement(
# line 316 "program.g"
action->u_enlist, ENLIST);
break;
case /*  CONVERT  */ 74 : ;
LL_SAFE(CONVERT);
# line 318 "program.g"
{ SetActionStruct(action, CONVERT);		}
L29_default_statement(
# line 319 "program.g"
action->u_convert, CONVERT);
break;
case /*  SHOOT  */ 75 : ;
LLsincr(16);
LL_SAFE(SHOOT);
# line 321 "program.g"
{ SetActionStruct(action, SHOOT);		}
L29_default_statement(
# line 322 "program.g"
action->u_shoot, SHOOT);
L_15: ;
switch(LLcsymb) {
case /*  CIVILIANS  */ 100 : ;
L_16: ;
LLsdecr(16);
LL_SSCANDONE(CIVILIANS);
# line 323 "program.g"
{ action->u_shoot->flag = 'c';		}
break;
default: if (LLskip()) goto L_15;
goto L_16;
case /*  UW  */ 47 : ;
LLsdecr(16);
LL_SAFE(UW);
# line 324 "program.g"
{ action->u_shoot->flag = 'u';		}
break;
}
LLread();
break;
case /*  SET_DISTRIBUTE  */ 77 : ;
LLtincr(66);
LLtincr(69);
LLsincr(14);
LL_SAFE(SET_DISTRIBUTE);
# line 327 "program.g"
{ SetActionStruct(action, SET_DISTRIBUTE); }
LLread();
L_17 : {switch(LLcsymb) {
case /*  TO  */ 69 : ;
LLtdecr(66);
break;
default:{int LL_15=LLnext(322);
;if (!LL_15) {
LLtdecr(66);
break;
}
else if (LL_15 & 1) goto L_17;}
case /*  FROM  */ 66 : ;
LLtdecr(66);
LL_SAFE(FROM);
LLread();
L7_sector_expression(
# line 328 "program.g"
&action->u_distribute->sector_expr);
LLread();
}
}
LLtdecr(69);
LL_SCANDONE(TO);
L28_location(
# line 329 "program.g"
&action->u_distribute->to_loc);
break;
case /*  SET_THRESHOLD  */ 78 : ;
LL_SAFE(SET_THRESHOLD);
# line 331 "program.g"
{ SetActionStruct(action, SET_THRESHOLD);  }
L30_default_commodity_statement(
# line 332 "program.g"
action->u_threshold, SET_THRESHOLD);
break;
case /*  SET_CUTOFF  */ 79 : ;
LL_SAFE(SET_CUTOFF);
# line 334 "program.g"
{ SetActionStruct(action, SET_CUTOFF);		}
L30_default_commodity_statement(
# line 335 "program.g"
action->u_cutoff, SET_CUTOFF);
break;
case /*  SET_DELIVER  */ 80 : ;
LLsincr(1);
LLsincr(15);
LLtincr(69);
LLsincr(1);
LL_SAFE(SET_DELIVER);
# line 337 "program.g"
{ SetActionStruct(action, SET_DELIVER);		}
LLread();
L_18 : {switch(LLcsymb) {
case /*  FOOD  */ 43 : ;
case /*  DUST  */ 44 : ;
case /*  OIL  */ 45 : ;
case /*  IRON  */ 46 : ;
case /*  UW  */ 47 : ;
case /*  GUNS  */ 48 : ;
case /*  BARS  */ 49 : ;
case /*  PETROL  */ 50 : ;
case /*  LCMS  */ 51 : ;
case /*  HCMS  */ 52 : ;
case /*  SHELLS  */ 53 : ;
case /*  RADS  */ 54 : ;
case /*  TOKEN_COMMODITY  */ 159 : ;
LLsdecr(1);
break;
default:{int LL_16=LLnext(-21);
;if (!LL_16) {
LLsdecr(1);
break;
}
else if (LL_16 & 1) goto L_18;}
case /*  SQUARE_BRACKET_OPEN  */ 23 : ;
case /*  CURRENT  */ 88 : ;
case /*  WAREHOUSE  */ 89 : ;
case /*  TOKEN_SECTOR  */ 156 : ;
LLsdecr(1);
L7_sector_expression(
# line 338 "program.g"
&action->u_deliver->sector_expr);
LLread();
}
}
L27_commodity(
# line 339 "program.g"
&action->u_deliver->commodity);
LLtdecr(69);
LL_NOSCANDONE(TO);
LLread();
LLsdecr(1);
L7_sector_expression(
# line 341 "program.g"
&action->u_deliver->dest_sector);
LLread();
break;
case /*  TERRITORY  */ 76 : ;
LL_SAFE(TERRITORY);
# line 343 "program.g"
{ SetActionStruct(action, TERRITORY);		}
L29_default_statement(
# line 344 "program.g"
action->u_territory, TERRITORY);
break;
}
L_19 : {switch(LLcsymb) {
case /*  EOFILE  */ 0 : ;
case /*  BEGIN  */ 55 : ;
case /*  END  */ 56 : ;
case /*  REPEAT  */ 57 : ;
case /*  UNTIL  */ 58 : ;
case /*  WHILE  */ 59 : ;
case /*  IF  */ 61 : ;
case /*  ELSE  */ 63 : ;
case /*  LOOP  */ 64 : ;
case /*  MOVE  */ 65 : ;
case /*  SET_DESIGNATION  */ 70 : ;
case /*  DEMOBILIZE  */ 71 : ;
case /*  ENLIST  */ 73 : ;
case /*  CONVERT  */ 74 : ;
case /*  SHOOT  */ 75 : ;
case /*  TERRITORY  */ 76 : ;
case /*  SET_DISTRIBUTE  */ 77 : ;
case /*  SET_THRESHOLD  */ 78 : ;
case /*  SET_CUTOFF  */ 79 : ;
case /*  SET_DELIVER  */ 80 : ;
case /*  BREAK  */ 82 : ;
case /*  CONTINUE  */ 83 : ;
case /*  ABORT  */ 84 : ;
case /*  STOP  */ 85 : ;
case /*  PRINT  */ 86 : ;
case /*  SEND  */ 87 : ;
case /*  TOKEN_STATEMENT  */ 157 : ;
LLtdecr(81);
break;
default:{int LL_17=LLnext(337);
;if (!LL_17) {
LLtdecr(81);
break;
}
else if (LL_17 & 1) goto L_19;}
case /*  ON_FAIL  */ 81 : ;
LLtdecr(81);
LL_SAFE(ON_FAIL);
# line 346 "program.g"
{ int error_label = next_label++;
				  AddInstructionLabel(error_label);
				  SetErrorLabel(instr, error_label);	}
L31_fail_clause(
# line 349 "program.g"
label_cont, label_break);
LLread();
}
}
# line 350 "program.g"
{ AddInstructionLabel(label_next);	}
break;
default:
LLtincr(56);
LL_SAFE(PRINT);
# line 351 "program.g"
{ SetActionStruct(action, PRINT);		}
L32_output_expr(
# line 352 "program.g"
&action->u_print);
LLtdecr(56);
LL_SCANDONE(END);
# line 353 "program.g"
{ AddInstructionLabel(label_next);		}
LLread();
break;
case /*  SEND  */ 87 : ;
LLtincr(56);
LL_SAFE(SEND);
# line 354 "program.g"
{ SetActionStruct(action, SEND);		}
L32_output_expr(
# line 355 "program.g"
&action->u_send);
LLtdecr(56);
LL_SCANDONE(END);
# line 356 "program.g"
{ AddInstructionLabel(label_next);		}
LLread();
break;
}
}
L27_commodity (
# line 359 "program.g"
 commodity) int *commodity; {
L_2: ;
switch(LLcsymb) {
case /*  FOOD  */ 43 : ;
case /*  DUST  */ 44 : ;
case /*  OIL  */ 45 : ;
case /*  IRON  */ 46 : ;
case /*  UW  */ 47 : ;
case /*  GUNS  */ 48 : ;
case /*  BARS  */ 49 : ;
case /*  PETROL  */ 50 : ;
case /*  LCMS  */ 51 : ;
case /*  HCMS  */ 52 : ;
case /*  SHELLS  */ 53 : ;
case /*  RADS  */ 54 : ;
LLsdecr(15);
# line 362 "program.g"
{ SetCommodityType(current_token.value, commodity);    }
break;
case /*  TOKEN_COMMODITY  */ 159 : ;
L_3: ;
LLsdecr(15);
LL_SSCANDONE(TOKEN_COMMODITY);
break;
default: if (LLskip()) goto L_2;
goto L_3;
}
}
L28_location (
# line 366 "program.g"
 loc) Location loc; {
# line 366 "program.g"
 int type; Stack expr;			       
LLread();
L_2: ;
switch(LLcsymb) {
case /*  SQUARE_BRACKET_OPEN  */ 23 : ;
case /*  CURRENT  */ 88 : ;
case /*  WAREHOUSE  */ 89 : ;
case /*  TOKEN_SECTOR  */ 156 : ;
L_3: ;
LLsdecr(14);
# line 367 "program.g"
{ loc->type = LOC_SECTOR;		       }
L7_sector_expression(
# line 368 "program.g"
&loc->l_sector_expr);
LLread();
break;
default: if (LLskip()) goto L_2;
goto L_3;
case /*  WHERE  */ 67 : ;
LLsdecr(14);
LLsincr(17);
# line 369 "program.g"
{ loc->type = LOC_WHERE;		       }
LLsdecr(17);
LLtincr(67);
for (;;) {
LL_SAFE(WHERE);
L4_parse_type_expression(
# line 371 "program.g"
&expr, &type);
# line 372 "program.g"
{ CheckType(&type, T_EVALUATE, E_ARG, WHERE);  }
# line 373 "program.g"
{ LinkExprList(&loc->l_where_list, expr);      }
L_4 : {switch(LLcsymb) {
case /*  EOFILE  */ 0 : ;
case /*  BEGIN  */ 55 : ;
case /*  END  */ 56 : ;
case /*  REPEAT  */ 57 : ;
case /*  UNTIL  */ 58 : ;
case /*  WHILE  */ 59 : ;
case /*  IF  */ 61 : ;
case /*  ELSE  */ 63 : ;
case /*  LOOP  */ 64 : ;
case /*  MOVE  */ 65 : ;
case /*  VIA  */ 68 : ;
case /*  TO  */ 69 : ;
case /*  SET_DESIGNATION  */ 70 : ;
case /*  DEMOBILIZE  */ 71 : ;
case /*  ENLIST  */ 73 : ;
case /*  CONVERT  */ 74 : ;
case /*  SHOOT  */ 75 : ;
case /*  TERRITORY  */ 76 : ;
case /*  SET_DISTRIBUTE  */ 77 : ;
case /*  SET_THRESHOLD  */ 78 : ;
case /*  SET_CUTOFF  */ 79 : ;
case /*  SET_DELIVER  */ 80 : ;
case /*  ON_FAIL  */ 81 : ;
case /*  BREAK  */ 82 : ;
case /*  CONTINUE  */ 83 : ;
case /*  ABORT  */ 84 : ;
case /*  STOP  */ 85 : ;
case /*  PRINT  */ 86 : ;
case /*  SEND  */ 87 : ;
case /*  TOKEN_STATEMENT  */ 157 : ;
break;
default:{int LL_18=LLnext(323);
;if (!LL_18) {
break;
}
else if (LL_18 & 1) goto L_4;}
case /*  WHERE  */ 67 : ;
continue;
}
}
LLtdecr(67);
break;
}
break;
}
}
L29_default_statement (
# line 377 "program.g"
 result,function) struct _Simple *result; int function; {
LLsincr(1);
LLsincr(0);
LLread();
L_1 : {switch(LLcsymb) {
case /*  SQUARE_BRACKET_OPEN  */ 23 : ;
case /*  CURRENT  */ 88 : ;
case /*  WAREHOUSE  */ 89 : ;
case /*  TOKEN_SECTOR  */ 156 : ;
# line 378 "program.g"
if ((current_token.symtab->type == T_SECTOR)) goto L_2;
case /*  CONSTANT  */ 1 : ;
case /*  CHARACTER  */ 2 : ;
case /*  STRING  */ 3 : ;
case /*  MINUS  */ 12 : ;
case /*  BRACKET_OPEN  */ 21 : ;
case /*  NOT  */ 29 : ;
case /*  TRUE  */ 30 : ;
case /*  FALSE  */ 31 : ;
case /*  POPULATION  */ 32 : ;
case /*  ROUND_FUNC  */ 33 : ;
case /*  FLOOR_FUNC  */ 34 : ;
case /*  CEIL_FUNC  */ 35 : ;
case /*  THRESHOLD_MOD  */ 36 : ;
case /*  RESOURCE_MOD  */ 37 : ;
case /*  SECTOR_MOD  */ 38 : ;
case /*  SHIP_MOD  */ 39 : ;
case /*  PLANE_MOD  */ 40 : ;
case /*  NUKE_MOD  */ 41 : ;
case /*  URANIUM  */ 42 : ;
case /*  FOOD  */ 43 : ;
case /*  DUST  */ 44 : ;
case /*  OIL  */ 45 : ;
case /*  IRON  */ 46 : ;
case /*  UW  */ 47 : ;
case /*  GUNS  */ 48 : ;
case /*  BARS  */ 49 : ;
case /*  PETROL  */ 50 : ;
case /*  LCMS  */ 51 : ;
case /*  HCMS  */ 52 : ;
case /*  SHELLS  */ 53 : ;
case /*  RADS  */ 54 : ;
case /*  BAD_SECTOR  */ 90 : ;
case /*  XLOC  */ 91 : ;
case /*  YLOC  */ 92 : ;
case /*  OWNER  */ 93 : ;
case /*  DESIGNATION  */ 94 : ;
case /*  NEW_DESIG  */ 95 : ;
case /*  EFFICIENCY  */ 96 : ;
case /*  WORK  */ 97 : ;
case /*  AVAILABLE  */ 98 : ;
case /*  MOBILITY  */ 99 : ;
case /*  CIVILIANS  */ 100 : ;
case /*  MILITARY  */ 101 : ;
case /*  PLANES  */ 102 : ;
case /*  SHIPS  */ 103 : ;
case /*  NUKES  */ 104 : ;
case /*  OCCUPIED  */ 105 : ;
case /*  OWNED  */ 106 : ;
case /*  COAST  */ 107 : ;
case /*  FOOD_USED  */ 108 : ;
case /*  STARVATION  */ 109 : ;
case /*  HAS_PLAN  */ 111 : ;
case /*  IS_ACTIVE  */ 112 : ;
case /*  PLAGUE  */ 113 : ;
case /*  PLAGUE_STAGE  */ 114 : ;
case /*  HAPPY  */ 115 : ;
case /*  HAPPY_STATE  */ 116 : ;
case /*  HAPPY_LOYAL  */ 117 : ;
case /*  HAPPY_UNREST  */ 118 : ;
case /*  HAPPY_REVOL  */ 119 : ;
case /*  HAPPY_TERROR  */ 120 : ;
case /*  HAPPY_GUERRE  */ 121 : ;
case /*  PLAGUE_HEALTHY  */ 122 : ;
case /*  PLAGUE_INFECTED  */ 123 : ;
case /*  PLAGUE_DYING  */ 124 : ;
case /*  SPE  */ 125 : ;
case /*  EPU  */ 126 : ;
case /*  IRATE  */ 127 : ;
case /*  CTRATE  */ 128 : ;
case /*  UTRATE  */ 129 : ;
case /*  AMCRATE  */ 130 : ;
case /*  RMCRATE  */ 131 : ;
case /*  FRATE  */ 132 : ;
case /*  HRATE  */ 133 : ;
case /*  CBRATE  */ 134 : ;
case /*  UBRATE  */ 135 : ;
case /*  ERATE  */ 136 : ;
case /*  BERATE  */ 137 : ;
case /*  NAME  */ 138 : ;
case /*  TYPE  */ 139 : ;
case /*  TECH  */ 140 : ;
case /*  NUMBER  */ 141 : ;
case /*  FLEET  */ 142 : ;
case /*  RADAR  */ 143 : ;
case /*  SONAR  */ 144 : ;
case /*  MOVES  */ 145 : ;
case /*  WING  */ 146 : ;
case /*  RANGE  */ 147 : ;
case /*  MAXRANGE  */ 148 : ;
case /*  ATTACK  */ 149 : ;
case /*  DEFENSE  */ 150 : ;
case /*  HARDEN  */ 151 : ;
case /*  LOAD  */ 152 : ;
case /*  STOCKPILE  */ 153 : ;
case /*  TOKEN_EXPRESSION  */ 154 : ;
case /*  TOKEN_NAME  */ 155 : ;
case /*  TOKEN_NUMERIC_EXPR  */ 158 : ;
LLsdecr(1);
break;
default:{int LL_19=LLnext(-21);
;if (!LL_19) {
LLsdecr(1);
break;
}
else if (LL_19 & 1) goto L_1;}
L_2 : ;
LLsdecr(1);
L7_sector_expression(
# line 379 "program.g"
&result->sector_expr);
LLread();
}
}
L5_numeric_expression(
# line 381 "program.g"
&result->quantity, function);
}
L30_default_commodity_statement (
# line 384 "program.g"
 result,function) struct _Simple *result; int function; {
LLsincr(1);
LLsincr(15);
LLsincr(0);
LLread();
L_1 : {switch(LLcsymb) {
case /*  FOOD  */ 43 : ;
case /*  DUST  */ 44 : ;
case /*  OIL  */ 45 : ;
case /*  IRON  */ 46 : ;
case /*  UW  */ 47 : ;
case /*  GUNS  */ 48 : ;
case /*  BARS  */ 49 : ;
case /*  PETROL  */ 50 : ;
case /*  LCMS  */ 51 : ;
case /*  HCMS  */ 52 : ;
case /*  SHELLS  */ 53 : ;
case /*  RADS  */ 54 : ;
case /*  TOKEN_COMMODITY  */ 159 : ;
LLsdecr(1);
break;
default:{int LL_20=LLnext(-21);
;if (!LL_20) {
LLsdecr(1);
break;
}
else if (LL_20 & 1) goto L_1;}
case /*  SQUARE_BRACKET_OPEN  */ 23 : ;
case /*  CURRENT  */ 88 : ;
case /*  WAREHOUSE  */ 89 : ;
case /*  TOKEN_SECTOR  */ 156 : ;
LLsdecr(1);
L7_sector_expression(
# line 385 "program.g"
&result->sector_expr);
LLread();
}
}
L27_commodity(
# line 386 "program.g"
&result->flag);
LLread();
L5_numeric_expression(
# line 387 "program.g"
&result->quantity, function);
}
L31_fail_clause (
# line 390 "program.g"
 label_cont,label_break) int label_cont, label_break; {
LLsincr(18);
L33_clause_statement(
# line 391 "program.g"
label_cont, label_break);
}
L33_clause_statement (
# line 400 "program.g"
 label_cont,label_break) int label_cont, label_break; {
LLread();
L_2: ;
switch(LLcsymb) {
case /*  BREAK  */ 82 : ;
LLsdecr(18);
LL_SAFE(BREAK);
# line 401 "program.g"
{ AddInstructionGoto(label_break);	}
break;
case /*  CONTINUE  */ 83 : ;
LLsdecr(18);
LL_SAFE(CONTINUE);
# line 402 "program.g"
{ AddInstructionGoto(label_cont);	}
break;
case /*  STOP  */ 85 : ;
LLsdecr(18);
LL_SAFE(STOP);
# line 403 "program.g"
{ AddInstructionGoto(1);		}
break;
case /*  ABORT  */ 84 : ;
LLsdecr(18);
LL_SAFE(ABORT);
# line 404 "program.g"
{ AddInstructionGoto(2);		}
break;
case /*  TOKEN_CLAUSE  */ 160 : ;
L_3: ;
LLsdecr(18);
LL_SSCANDONE(TOKEN_CLAUSE);
break;
default: if (LLskip()) goto L_2;
goto L_3;
}
}
L32_output_expr (
# line 408 "program.g"
 list) Output *list; {
# line 408 "program.g"
 Stack expr;			
LLsincr(2);
LLread();
for (;;) {
L_1 : {switch(LLcsymb) {
case /*  END  */ 56 : ;
break;
default:{int LL_21=LLnext(-42);
;if (!LL_21) {
break;
}
else if (LL_21 & 1) goto L_1;}
case /*  CONSTANT  */ 1 : ;
case /*  CHARACTER  */ 2 : ;
case /*  STRING  */ 3 : ;
case /*  MINUS  */ 12 : ;
case /*  BRACKET_OPEN  */ 21 : ;
case /*  SQUARE_BRACKET_OPEN  */ 23 : ;
case /*  NOT  */ 29 : ;
case /*  TRUE  */ 30 : ;
case /*  FALSE  */ 31 : ;
case /*  POPULATION  */ 32 : ;
case /*  ROUND_FUNC  */ 33 : ;
case /*  FLOOR_FUNC  */ 34 : ;
case /*  CEIL_FUNC  */ 35 : ;
case /*  THRESHOLD_MOD  */ 36 : ;
case /*  RESOURCE_MOD  */ 37 : ;
case /*  SECTOR_MOD  */ 38 : ;
case /*  SHIP_MOD  */ 39 : ;
case /*  PLANE_MOD  */ 40 : ;
case /*  NUKE_MOD  */ 41 : ;
case /*  URANIUM  */ 42 : ;
case /*  FOOD  */ 43 : ;
case /*  DUST  */ 44 : ;
case /*  OIL  */ 45 : ;
case /*  IRON  */ 46 : ;
case /*  UW  */ 47 : ;
case /*  GUNS  */ 48 : ;
case /*  BARS  */ 49 : ;
case /*  PETROL  */ 50 : ;
case /*  LCMS  */ 51 : ;
case /*  HCMS  */ 52 : ;
case /*  SHELLS  */ 53 : ;
case /*  RADS  */ 54 : ;
case /*  CURRENT  */ 88 : ;
case /*  WAREHOUSE  */ 89 : ;
case /*  BAD_SECTOR  */ 90 : ;
case /*  XLOC  */ 91 : ;
case /*  YLOC  */ 92 : ;
case /*  OWNER  */ 93 : ;
case /*  DESIGNATION  */ 94 : ;
case /*  NEW_DESIG  */ 95 : ;
case /*  EFFICIENCY  */ 96 : ;
case /*  WORK  */ 97 : ;
case /*  AVAILABLE  */ 98 : ;
case /*  MOBILITY  */ 99 : ;
case /*  CIVILIANS  */ 100 : ;
case /*  MILITARY  */ 101 : ;
case /*  PLANES  */ 102 : ;
case /*  SHIPS  */ 103 : ;
case /*  NUKES  */ 104 : ;
case /*  OCCUPIED  */ 105 : ;
case /*  OWNED  */ 106 : ;
case /*  COAST  */ 107 : ;
case /*  FOOD_USED  */ 108 : ;
case /*  STARVATION  */ 109 : ;
case /*  HAS_PLAN  */ 111 : ;
case /*  IS_ACTIVE  */ 112 : ;
case /*  PLAGUE  */ 113 : ;
case /*  PLAGUE_STAGE  */ 114 : ;
case /*  HAPPY  */ 115 : ;
case /*  HAPPY_STATE  */ 116 : ;
case /*  HAPPY_LOYAL  */ 117 : ;
case /*  HAPPY_UNREST  */ 118 : ;
case /*  HAPPY_REVOL  */ 119 : ;
case /*  HAPPY_TERROR  */ 120 : ;
case /*  HAPPY_GUERRE  */ 121 : ;
case /*  PLAGUE_HEALTHY  */ 122 : ;
case /*  PLAGUE_INFECTED  */ 123 : ;
case /*  PLAGUE_DYING  */ 124 : ;
case /*  SPE  */ 125 : ;
case /*  EPU  */ 126 : ;
case /*  IRATE  */ 127 : ;
case /*  CTRATE  */ 128 : ;
case /*  UTRATE  */ 129 : ;
case /*  AMCRATE  */ 130 : ;
case /*  RMCRATE  */ 131 : ;
case /*  FRATE  */ 132 : ;
case /*  HRATE  */ 133 : ;
case /*  CBRATE  */ 134 : ;
case /*  UBRATE  */ 135 : ;
case /*  ERATE  */ 136 : ;
case /*  BERATE  */ 137 : ;
case /*  NAME  */ 138 : ;
case /*  TYPE  */ 139 : ;
case /*  TECH  */ 140 : ;
case /*  NUMBER  */ 141 : ;
case /*  FLEET  */ 142 : ;
case /*  RADAR  */ 143 : ;
case /*  SONAR  */ 144 : ;
case /*  MOVES  */ 145 : ;
case /*  WING  */ 146 : ;
case /*  RANGE  */ 147 : ;
case /*  MAXRANGE  */ 148 : ;
case /*  ATTACK  */ 149 : ;
case /*  DEFENSE  */ 150 : ;
case /*  HARDEN  */ 151 : ;
case /*  LOAD  */ 152 : ;
case /*  STOCKPILE  */ 153 : ;
case /*  TOKEN_EXPRESSION  */ 154 : ;
case /*  TOKEN_NAME  */ 155 : ;
case /*  TOKEN_SECTOR  */ 156 : ;
LLtincr(26);
L9_parse_factor(
# line 409 "program.g"
&expr);
# line 409 "program.g"
{ LinkOutputList(list, expr);	}
L_2 : {switch(LLcsymb) {
case /*  CONSTANT  */ 1 : ;
case /*  CHARACTER  */ 2 : ;
case /*  STRING  */ 3 : ;
case /*  MINUS  */ 12 : ;
case /*  BRACKET_OPEN  */ 21 : ;
case /*  SQUARE_BRACKET_OPEN  */ 23 : ;
case /*  NOT  */ 29 : ;
case /*  TRUE  */ 30 : ;
case /*  FALSE  */ 31 : ;
case /*  POPULATION  */ 32 : ;
case /*  ROUND_FUNC  */ 33 : ;
case /*  FLOOR_FUNC  */ 34 : ;
case /*  CEIL_FUNC  */ 35 : ;
case /*  THRESHOLD_MOD  */ 36 : ;
case /*  RESOURCE_MOD  */ 37 : ;
case /*  SECTOR_MOD  */ 38 : ;
case /*  SHIP_MOD  */ 39 : ;
case /*  PLANE_MOD  */ 40 : ;
case /*  NUKE_MOD  */ 41 : ;
case /*  URANIUM  */ 42 : ;
case /*  FOOD  */ 43 : ;
case /*  DUST  */ 44 : ;
case /*  OIL  */ 45 : ;
case /*  IRON  */ 46 : ;
case /*  UW  */ 47 : ;
case /*  GUNS  */ 48 : ;
case /*  BARS  */ 49 : ;
case /*  PETROL  */ 50 : ;
case /*  LCMS  */ 51 : ;
case /*  HCMS  */ 52 : ;
case /*  SHELLS  */ 53 : ;
case /*  RADS  */ 54 : ;
case /*  END  */ 56 : ;
case /*  CURRENT  */ 88 : ;
case /*  WAREHOUSE  */ 89 : ;
case /*  BAD_SECTOR  */ 90 : ;
case /*  XLOC  */ 91 : ;
case /*  YLOC  */ 92 : ;
case /*  OWNER  */ 93 : ;
case /*  DESIGNATION  */ 94 : ;
case /*  NEW_DESIG  */ 95 : ;
case /*  EFFICIENCY  */ 96 : ;
case /*  WORK  */ 97 : ;
case /*  AVAILABLE  */ 98 : ;
case /*  MOBILITY  */ 99 : ;
case /*  CIVILIANS  */ 100 : ;
case /*  MILITARY  */ 101 : ;
case /*  PLANES  */ 102 : ;
case /*  SHIPS  */ 103 : ;
case /*  NUKES  */ 104 : ;
case /*  OCCUPIED  */ 105 : ;
case /*  OWNED  */ 106 : ;
case /*  COAST  */ 107 : ;
case /*  FOOD_USED  */ 108 : ;
case /*  STARVATION  */ 109 : ;
case /*  HAS_PLAN  */ 111 : ;
case /*  IS_ACTIVE  */ 112 : ;
case /*  PLAGUE  */ 113 : ;
case /*  PLAGUE_STAGE  */ 114 : ;
case /*  HAPPY  */ 115 : ;
case /*  HAPPY_STATE  */ 116 : ;
case /*  HAPPY_LOYAL  */ 117 : ;
case /*  HAPPY_UNREST  */ 118 : ;
case /*  HAPPY_REVOL  */ 119 : ;
case /*  HAPPY_TERROR  */ 120 : ;
case /*  HAPPY_GUERRE  */ 121 : ;
case /*  PLAGUE_HEALTHY  */ 122 : ;
case /*  PLAGUE_INFECTED  */ 123 : ;
case /*  PLAGUE_DYING  */ 124 : ;
case /*  SPE  */ 125 : ;
case /*  EPU  */ 126 : ;
case /*  IRATE  */ 127 : ;
case /*  CTRATE  */ 128 : ;
case /*  UTRATE  */ 129 : ;
case /*  AMCRATE  */ 130 : ;
case /*  RMCRATE  */ 131 : ;
case /*  FRATE  */ 132 : ;
case /*  HRATE  */ 133 : ;
case /*  CBRATE  */ 134 : ;
case /*  UBRATE  */ 135 : ;
case /*  ERATE  */ 136 : ;
case /*  BERATE  */ 137 : ;
case /*  NAME  */ 138 : ;
case /*  TYPE  */ 139 : ;
case /*  TECH  */ 140 : ;
case /*  NUMBER  */ 141 : ;
case /*  FLEET  */ 142 : ;
case /*  RADAR  */ 143 : ;
case /*  SONAR  */ 144 : ;
case /*  MOVES  */ 145 : ;
case /*  WING  */ 146 : ;
case /*  RANGE  */ 147 : ;
case /*  MAXRANGE  */ 148 : ;
case /*  ATTACK  */ 149 : ;
case /*  DEFENSE  */ 150 : ;
case /*  HARDEN  */ 151 : ;
case /*  LOAD  */ 152 : ;
case /*  STOCKPILE  */ 153 : ;
case /*  TOKEN_EXPRESSION  */ 154 : ;
case /*  TOKEN_NAME  */ 155 : ;
case /*  TOKEN_SECTOR  */ 156 : ;
LLtdecr(26);
break;
default:{int LL_22=LLnext(282);
;if (!LL_22) {
LLtdecr(26);
break;
}
else if (LL_22 & 1) goto L_2;}
case /*  COLON  */ 26 : ;
LLtdecr(26);
LL_SAFE(COLON);
LL_NOSCANDONE(CONSTANT);
# line 411 "program.g"
{ (*list)->o_tail->format = (int)
						(current_token.t_constant); }
LLread();
}
}
continue;
}
}
LLsdecr(2);
break;
}
}


